<template>
  <div class="field has-addons">
    <div class="control is-expanded has-icons-right">
      <input class="input" type="text" :placeholder="placeholder" disabled />
    </div>
    <div class="control">
      <a
        v-on:click="registerSuccess"
        class="clipboard button is-white"
        :data-clipboard-text="placeholder"
      >
        <span class="icon is-small is-right">
          <svg
            v-if="copySuccess"
            role="img"
            xmlns="http://www.w3.org/2000/svg"
            width="24"
            height="24"
            viewBox="0 0 24 24"
            aria-labelledby="okIconTitle okIconDesc"
            stroke="#3593d1"
            stroke-width="1.5"
            stroke-linecap="square"
            stroke-linejoin="miter"
            fill="none"
            color="#3593d1"
          >
            <title id="okIconTitle">Ok</title>
            <desc id="okIconDesc">Icon of a checkmark</desc>
            <polyline points="4 13 9 18 20 7" />
          </svg>
          <svg
            v-else
            role="img"
            xmlns="http://www.w3.org/2000/svg"
            width="24"
            height="24"
            viewBox="0 0 24 24"
            aria-labelledby="copyIconTitle copyIconDesc"
            stroke="#3593d1"
            stroke-width="1.5"
            stroke-linecap="square"
            stroke-linejoin="miter"
            fill="none"
            color="#3593d1"
          >
            <title id="copyIconTitle">Copy</title>
            <desc id="copyIconDesc">Copy active/selected item(s)</desc>
            <rect width="12" height="14" x="8" y="7" />
            <polyline points="16 3 4 3 4 17" />
          </svg>
        </span>
      </a>
    </div>
  </div>
</template>

<script lang="ts">
import { Component, Vue, Prop } from "vue-property-decorator";
import Clipboard from "clipboard";

@Component
export default class ADisabledInput extends Vue {
  @Prop() placeholder!: string;
  copySuccess: boolean = false;
  clipboard!: Clipboard;

  registerSuccess() {
    this.copySuccess = true;
    window.setTimeout(() => {
      this.copySuccess = false;
    }, 1000);
  }

  private mounted() {
    this.clipboard = new Clipboard(".clipboard");
  }

  private destroyed() {
    this.clipboard.destroy();
  }
}
</script>

<style lang="scss" scoped>
input[disabled]::placeholder {
  color: $black;
}
</style>
